/*!
 *
 * Bryntum Gantt 4.2.7 (TRIAL VERSION)
 *
 * Copyright(c) 2021 Bryntum AB
 * https://bryntum.com/contact
 * https://bryntum.com/license
 *
 */
import { Component, OnInit } from '@angular/core';
import ganttConfig from './gantt.config';
import { ProjectModel } from "@bryntum/gantt/gantt.lite.umd.js"

@Component({
  selector: 'app-gantt',
  templateUrl: './gantt.component.html'
})
export class GanttComponent implements OnInit {
  ganttConfig = ganttConfig;
  public projectModel: ProjectModel = new ProjectModel(
    {
      autoLoad: false,
      validateResponse: false
    });
  public dates = { startDate: '2019-01-12', endDate: '2019-03-24' }
  ngOnInit() {
    this.loadData();
  }

  public loadData() {
    const data = this.data;
    // this.projectModel = new ProjectModel({ autoLoad: false });
    this.projectModel.loadCrudManagerData(data);
  }

  public get data() {
    return {
      "success": true,

      "project": {
        "calendar": "general",
        "startDate": "2019-01-14",
        // "hoursPerDay": 24,
        // "daysPerWeek": 5,
        // "daysPerMonth": 20
      },

      "calendars": {
        "rows": [
          {
            "id": "general",
            "name": "General",
            "intervals": [
              {
                // "recurrentStartDate": "on Sat at 0:00",
                // "recurrentEndDate": "on Mon at 0:00",
                // "isWorking": false
              }
            ],
            "expanded": true,
            "children": []
          }
        ]
      },

      "tasks": {
        "rows": [
          {
            "id": 1000,
            "name": "Launch SaaS Product",
            "percentDone": 50,
            "startDate": "2019-01-15",
            "expanded": true,
            "testColumn":"100",
            "children": [
              {
                "id": 1,
                "name": "Setup web server",
                "percentDone": 50,
                "duration": 10,
                "startDate": "2019-01-14",
                "rollup": true,
                "endDate": "2019-01-23",
                "expanded": true,
                "children": [
                  {
                    "id": 11,
                    "name": "Install Apache",
                    "percentDone": 50,
                    "startDate": "2019-01-14",
                    "rollup": true,
                    "duration": 3,
                    "color": "teal",
                    "endDate": "2019-01-17",
                    "cost": 200,
                    "baselines": [
                      {
                        "startDate": "2019-01-13T23:00:00",
                        "endDate": "2019-01-16T23:00:00"
                      },
                      {
                        "startDate": "2019-01-13T23:00:00",
                        "endDate": "2019-01-16T23:00:00"
                      },
                      {
                        "startDate": "2019-01-13T23:00:00",
                        "endDate": "2019-01-16T23:00:00"
                      }
                    ]
                  },
                  {
                    "id": 12,
                    "name": "Configure firewall",
                    "percentDone": 50,
                    "startDate": "2019-01-14",
                    "rollup": true,
                    "duration": 3,
                    "endDate": "2019-01-17",
                    "showInTimeline": true,
                    "cost": 1000,
                    "baselines": [
                      {
                        "startDate": "2019-01-13T23:00:00",
                        "endDate": "2019-01-16T23:00:00"
                      },
                      {
                        "startDate": "2019-01-13T23:00:00",
                        "endDate": "2019-01-16T23:00:00"
                      },
                      {
                        "startDate": "2019-01-13T23:00:00",
                        "endDate": "2019-01-16T23:00:00"
                      }
                    ]
                  },
                  {
                    "id": 13,
                    "name": "Setup load balancer",
                    "percentDone": 50,
                    "startDate": "2019-01-14",
                    "rollup": true,
                    "duration": 3,
                    "endDate": "2019-01-17",
                    "cost": 1200,
                    "baselines": [
                      {
                        "startDate": "2019-01-13T23:00:00",
                        "endDate": "2019-01-16T23:00:00"
                      },
                      {
                        "startDate": "2019-01-13T23:00:00",
                        "endDate": "2019-01-16T23:00:00"
                      },
                      {
                        "startDate": "2019-01-13T23:00:00",
                        "endDate": "2019-01-16T23:00:00"
                      }
                    ]
                  },
                  {
                    "id": 14,
                    "name": "Configure ports",
                    "percentDone": 50,
                    "startDate": "2019-01-18",
                    "rollup": true,
                    "duration": 2,
                    "endDate": "2019-01-16",
                    "cost": 750,
                    "baselines": [
                      {
                        "startDate": "2019-01-13T23:00:00",
                        "endDate": "2019-01-15T23:00:00"
                      },
                      {
                        "startDate": "2019-01-13T23:00:00",
                        "endDate": "2019-01-15T23:00:00"
                      },
                      {
                        "startDate": "2019-01-13T23:00:00",
                        "endDate": "2019-01-15T23:00:00"
                      }
                    ]
                  },
                  {
                    "id": 15,
                    "name": "Run tests",
                    "percentDone": 0,
                    "startDate": "2019-01-24",
                    "rollup": true,
                    "duration": 4,
                    "endDate": "2019-01-27",
                    "manuallyScheduled": "true",
                    "cost": 5000,
                    "testColumn":"100"
                  }
                ],
                "baselines": [
                  {
                    "startDate": "2019-01-13T23:00:00",
                    "endDate": "2019-01-22T23:00:00"
                  },
                  {
                    "startDate": "2019-01-13T23:00:00",
                    "endDate": "2019-01-22T23:00:00"
                  },
                  {
                    "startDate": "2019-01-13T23:00:00",
                    "endDate": "2019-01-22T23:00:00"
                  }
                ]
              }
            ],
            "endDate": "2019-03-16",
            "baselines": [
              {
                "startDate": "2019-01-13T23:00:00",
                "endDate": "2019-03-15T23:00:00"
              },
              {
                "startDate": "2019-01-13T23:00:00",
                "endDate": "2019-03-15T23:00:00"
              },
              {
                "startDate": "2019-01-13T23:00:00",
                "endDate": "2019-03-15T23:00:00"
              }
            ]
          }
        ]
      },

      "dependencies": {
        "rows": [
          {
            "id": 1,
            "fromTask": 11,
            "toTask": 15,
            "lag": 2
          },
          {
            "id": 2,
            "fromTask": 12,
            "toTask": 15
          },
          {
            "id": 3,
            "fromTask": 13,
            "toTask": 15
          },
          {
            "id": 4,
            "fromTask": 14,
            "toTask": 15
          },
          {
            "id": 5,
            "fromTask": 15,
            "toTask": 21
          },
          {
            "id": 7,
            "fromTask": 21,
            "toTask": 22
          },
          {
            "id": 8,
            "fromTask": 22,
            "toTask": 23
          },
          {
            "id": 9,
            "fromTask": 23,
            "toTask": 24
          },
          {
            "id": 10,
            "fromTask": 24,
            "toTask": 25
          },
          {
            "id": 11,
            "fromTask": 31,
            "toTask": 331
          },
          {
            "id": 111,
            "fromTask": 31,
            "toTask": 332
          },
          {
            "id": 112,
            "fromTask": 31,
            "toTask": 333
          },
          {
            "id": 113,
            "fromTask": 31,
            "toTask": 334
          },
          {
            "id": 12,
            "fromTask": 400,
            "toTask": 401
          },
          {
            "id": 13,
            "fromTask": 401,
            "toTask": 402
          },
          {
            "id": 15,
            "fromTask": 3,
            "toTask": 4
          },
          {
            "id": 16,
            "fromTask": 41,
            "toTask": 45
          },
          {
            "id": 17,
            "fromTask": 42,
            "toTask": 45
          },
          {
            "id": 18,
            "fromTask": 43,
            "toTask": 45
          },
          {
            "id": 19,
            "fromTask": 44,
            "toTask": 45
          },
          {
            "id": 20,
            "fromTask": 4034,
            "toTask": 4035
          }
        ]
      },

      "resources": {
        "rows": [
          // { "id" : 1, "name" : "Celia", "city" : "Barcelona", "calendar" : null, "image" : "celia.jpg" },
          // { "id" : 2, "name" : "Lee", "city" : "London", "calendar" : null, "image" : "lee.jpg"  },
          // { "id" : 3, "name" : "Macy", "city" : "New York","calendar" : null, "image" : "macy.jpg"  },
          // { "id" : 4, "name" : "Madison", "city" : "Barcelona", "calendar" : null,"image" : "madison.jpg"  },
          // { "id" : 5, "name" : "Rob", "city" : "Rome", "calendar" : "business", "image" : "rob.jpg"  },
          // { "id" : 6, "name" : "Dave", "city" : "Barcelona", "calendar" : "night", "image" : "dave.jpg"  },
          // { "id" : 7, "name" : "Dan", "city" : "London", "calendar" : "night", "image" : "dan.jpg"  },
          // { "id" : 8, "name" : "George", "city" : "New York", "calendar" : null, "image" : "george.jpg"  },
          // { "id" : 9, "name" : "Gloria", "city" : "Rome", "calendar" : null, "image" : "gloria.jpg"  },
          // { "id" : 10, "name" : "Henrik", "city" : "London", "calendar" : null, "image" : "henrik.jpg"  }
        ]
      },

      "assignments": {
        "rows": [
          { "id": 1, "event": 11, "resource": 1 },
          { "id": 2, "event": 4033, "resource": 1 },
          { "id": 3, "event": 12, "resource": 9 },
          { "id": 4, "event": 13, "resource": 2 },
          { "id": 5, "event": 13, "resource": 3 },
          { "id": 6, "event": 13, "resource": 6 },
          { "id": 7, "event": 13, "resource": 7 },
          { "id": 8, "event": 13, "resource": 8 },
          { "id": 9, "event": 21, "resource": 5 },
          { "id": 10, "event": 21, "resource": 9 },
          { "id": 11, "event": 22, "resource": 8 },
          { "id": 12, "event": 25, "resource": 3 }
        ]
      },

      "timeRanges": {
        "rows": [
          // {
          //   "id"       : 1,
          //   "name"     : "Important date",
          //   "startDate": "2019-01-30",
          //   "duration" : 0,
          //   "durationUnit" : "d",
          //   "cls"      : "b-fa b-fa-diamond"
          // }
        ]
      }
    }
  }
}
