/*!
 *
 * Bryntum Gantt 4.2.7 (TRIAL VERSION)
 *
 * Copyright(c) 2021 Bryntum AB
 * https://bryntum.com/contact
 * https://bryntum.com/license
 *
 */
import '../lib/GanttToolbar.js';
import '../lib/StatusColumn.js';
import Task from '../lib/Task.js';

const ganttConfig = {
    dependencyIdField: 'wbsCode',

    // project : {
    //     // Let the Project know we want to use our own Task model with custom fields / methods
    //     taskModelClass : Task,
    //     transport      : {
    //         load : {
    //             url : 'assets/data/launch-saas.json'
    //         }
    //     },
    //     autoLoad : true,

    //     // The State TrackingManager which the UndoRedo widget in the toolbar uses
    //     stm : {
    //         autoRecord : true
    //     },

    //     // This config enables response validation and dumping of found errors to the browser console.
    //     // It's meant to be used as a development stage helper only so please set it to false for production systems.
    //     validateResponse : true
    // },

    startDate: '2019-01-12',
    endDate: '2019-03-24',
    // resourceImageFolderPath : 'assets/users/',
    columns: [
        { type: 'wbs' },
        { type: 'name', width: 250 },
        { type: 'startdate', text: 'test data' },
        { type: 'duration' },
        { type: 'resourceassignment', width: 120, showAvatars: true },
        { type: 'percentdone', showCircle: true, width: 70 },
        {
            type: 'predecessor',
            width: 112
        },
        {
            type: 'successor',
            width: 112
        },
        { type: 'schedulingmodecolumn' },
        { type: 'calendar' },
        { type: 'constrainttype' },
        { type: 'constraintdate' },
        // { type : 'statuscolumn' },
        {
            text: 'Test Column',
            field: 'testColumn'
        },
        { type: 'addnew' }
    ],

    subGridConfigs: {
        locked: {
            flex: 3
        },
        normal: {
            flex: 4
        }
    },

    columnLines: false,

    features: {
        taskDrag: {
            validatorFn: (taskEditor: any, startDate: any) => {
                return true;
            }
        },
        rollups: {
            disabled: true
        },
        baselines: {
            disabled: true
        },
        progressLine: {
            disabled: true,
            statusDate: new Date(2019, 0, 25)
        },
        filter: true,
        dependencyEdit: true,
        timeRanges: {
            showCurrentTimeLine: true
        },
        labels: {
            left: {
                field: 'name',
                editor: {
                    type: 'textfield'
                }
            }
        },
        taskEdit: {
            items: {
                // Remove all tabs except the "General" tab
                notesTab: false,
                predecessorsTab: false,
                successorsTab: false,
                resourcesTab: false,
                advancedTab: false,
                generalTab: {
                    // Rename "General" tab
                    title: 'Activity Information',
                    items: {
                        name:{
                            disabled:true
                        },
                        // Rename "% Complete" field
                        percentDone: {
                            label: 'Progress',
                            disable:true
                        },
                        effort: false
                    }
                }
            }

        }
    },

    tbar: {
        type : 'gantttoolbar'
    },
    listeners: {
        beforeTaskSave: (event: any) => {
            console.log(event);
        },
        beforeTaskEdit: (event: any) => {
            console.log(event);
        },
        beforeTaskEditShow: (event: any) => {
            console.log(event);
        },
        beforetaskdrag: (event: any) => {
            console.log(event);
        },
        beforetaskresize: (event: any) => {
           console.log();
        },
        taskResizeEnd: (event: any) => {
          console.log();
        },
        taskDrop: (event: any) => {
            console.log(event);
        },
        taskDrag: (event: any) => {
            console.log("hellooooooooo");
            console.log(event);
        }
    }
};

export default ganttConfig;
